import { ActionObserver, EventDelegate } from '@yukawa/chain-base-angular-client';
import { Observable } from 'rxjs';
import { Nullable } from 'simplytyped';
import { Credentials } from '../model/user';
import { ISessionService } from './ISessionService';
import { ISessionChangeOptions, SessionChangedEventArgs } from './SessionChangedEventArgs';
import { User } from './user/User';
export declare abstract class Session extends ActionObserver<Session> {
    #private;
    protected _user?: Nullable<User>;
    static readonly SessionDisconnected: typeof SessionDisconnected;
    static readonly SessionConnected: typeof SessionConnected;
    private static readonly _sessionChanged;
    protected constructor(_user?: Nullable<User>);
    static get sessionChanged(): EventDelegate<Session, SessionChangedEventArgs>;
    static get instance(): Session;
    get user(): Nullable<User>;
    static restore(sessionService: ISessionService): Promise<boolean>;
    static refresh(sessionService: ISessionService): Observable<Session>;
    protected onSessionChanged(sender: Session, ea: SessionChangedEventArgs): void;
    abstract login(sessionService: ISessionService, credentials: Credentials): Promise<Session>;
    abstract logout(sessionService: ISessionService, options?: ISessionChangeOptions): void;
}
export declare class SessionDisconnected extends Session {
    constructor();
    login(sessionService: ISessionService, credentials: Credentials): Promise<Session>;
    logout(sessionService: ISessionService): void;
}
export declare class SessionConnected extends Session {
    constructor(user: User);
    get user(): User;
    login(sessionService: ISessionService, credentials: Credentials): Promise<Session>;
    logout(sessionService: ISessionService, options?: ISessionChangeOptions): void;
}
