import { ObjectBase } from '@awesome-nodes/object/data';
import { IAuthDetails, IAuthRefreshDetails, IAuthTokenResponse, IWebTokenPayload, TokenType } from '../../services';
import { WebToken } from '../jwt';
export declare class AuthToken extends ObjectBase implements IAuthTokenResponse {
    private readonly _access_expires;
    private readonly _access_token;
    private readonly _details;
    private readonly _expires_in;
    private readonly _refresh_expires;
    private readonly _refresh_token;
    private readonly _scope;
    private readonly _token_type;
    private readonly _username;
    private readonly _accessToken;
    private readonly _refreshToken;
    constructor(authTokenResponse: IAuthTokenResponse);
    get access_expires(): string;
    get access_token(): string;
    get details(): IAuthDetails | IAuthRefreshDetails;
    get expires_in(): number;
    get refresh_expires(): string;
    get refresh_token(): string;
    get scope(): Array<string>;
    get token_type(): TokenType;
    get username(): string;
    get accessToken(): WebToken<IWebTokenPayload>;
    get refreshToken(): WebToken<IWebTokenPayload>;
    get access_expired(): boolean;
    get refresh_expired(): boolean;
    toJSON(): IAuthTokenResponse;
}
