import { IEquatable } from '@awesome-nodes/object';
import { ObjectBase } from '@awesome-nodes/object/data';
import { Change, Owner } from '@yukawa/chain-base-angular-domain';
import { User } from '@yukawa/chain-main-angular-core';
import { GroupContext } from '@yukawa/chain-security-angular-core';
import { Account } from './Account';
import { Person } from './Person';
export declare class UserInfo extends ObjectBase implements User, IEquatable<UserInfo> {
    static readonly empty: UserInfo;
    private _account?;
    private _change?;
    private _created?;
    private _defaultOrgId?;
    private _details;
    private _groupContexts;
    private _orgIds;
    private _owner?;
    private _person;
    private _username;
    constructor(user: User);
    get account(): Account | undefined;
    set account(value: Account | undefined);
    get change(): Change | undefined;
    set change(value: Change | undefined);
    get created(): Change | undefined;
    set created(value: Change | undefined);
    get defaultOrgId(): string | undefined;
    set defaultOrgId(value: string | undefined);
    get details(): {
        [p: string]: object;
    };
    set details(value: {
        [p: string]: object;
    });
    get groupContexts(): GroupContext[];
    set groupContexts(value: GroupContext[]);
    get orgIds(): string[];
    set orgIds(value: string[]);
    get owner(): Owner | undefined;
    set owner(value: Owner | undefined);
    get person(): Person;
    set person(value: Person);
    get username(): string;
    set username(value: string);
    equals(other: UserInfo): boolean;
    toJSON<T = this>(): User;
}
